
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Journal_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.create(
            {
                id: data.id || undefined,
        
        dc: data.dc
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        line_memo: data.line_memo
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await journal_lines.setJournal_entry( data.journal_entry || null, {
            transaction,
        });
        
        await journal_lines.setAccount( data.account || null, {
            transaction,
        });
        
        await journal_lines.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return journal_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const journal_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                dc: item.dc
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                line_memo: item.line_memo
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const journal_lines = await db.journal_lines.bulkCreate(journal_linesData, { transaction });

        // For each item created, replace relation files
        

        return journal_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const journal_lines = await db.journal_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.dc !== undefined) updatePayload.dc = data.dc;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.line_memo !== undefined) updatePayload.line_memo = data.line_memo;
        
        
        updatePayload.updatedById = currentUser.id;

        await journal_lines.update(updatePayload, {transaction});

        
        
        if (data.journal_entry !== undefined) {
            await journal_lines.setJournal_entry(
              
              data.journal_entry,
              
              { transaction }
            );
        }
        
        if (data.account !== undefined) {
            await journal_lines.setAccount(
              
              data.account,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await journal_lines.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return journal_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of journal_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of journal_lines) {
                await record.destroy({transaction});
            }
        });


        return journal_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.findByPk(id, options);

        await journal_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await journal_lines.destroy({
            transaction
        });

        return journal_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.findOne(
            { where },
            { transaction },
        );

        if (!journal_lines) {
            return journal_lines;
        }

        const output = journal_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.journal_entry = await journal_lines.getJournal_entry({
            transaction
        });
        
        
        output.account = await journal_lines.getAccount({
            transaction
        });
        
        
        output.organizations = await journal_lines.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.journal_entries,
        as: 'journal_entry',
        
        where: filter.journal_entry ? {
          [Op.or]: [
            { id: { [Op.in]: filter.journal_entry.split('|').map(term => Utils.uuid(term)) } },
            {
              entry_number: {
                [Op.or]: filter.journal_entry.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.chart_accounts,
        as: 'account',
        
        where: filter.account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_name: {
                [Op.or]: filter.account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.line_memo) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'journal_lines',
                        'line_memo',
                        filter.line_memo,
                    ),
                };
            }
            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.dc) {
                where = {
                    ...where,
                dc: filter.dc,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.journal_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'journal_lines',
                        'line_memo',
                        query,
                    ),
                ],
            };
        }

        const records = await db.journal_lines.findAll({
            attributes: [ 'id', 'line_memo' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['line_memo', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.line_memo,
        }));
    }

    
};

